#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Fuchsia
#property indicator_color3 Gold

extern string _ = "MACD settings";
extern int FastEMA = 12;
extern int SlowEMA = 26;
extern int SignalEMA = 9;
extern int PriceType = 0;
bool Gi_100 = FALSE;
extern int OsmaMultiplier = 2;
bool Gi_108 = TRUE;
extern int RSIPeriod = 14;
extern int MOMPeriod = 14;
extern int CCIPeriod = 10;
extern int StoK_period = 14;
extern int StoD_period = 3;
extern int StoSl_period = 3;
extern int StoPriceField = 0;
extern int StoMain_MaMode = 0;
extern int StoSig_MaMode = 0;
extern int baseMaPeriod = 1;
extern int baseMaMode = 0;
extern int MACDType = 0;
extern string note_MACD_Types_ = "0 regularMACD-ema 1ZeroLagMACD 2MACDofRSI  3MACDofMomentum 4MACDofCCI 5MACDofStochastic";
extern string Sto_PriceField_ = "0Low/High  1Close/Close";
extern string __ = "alerts";
extern bool alertsOn = FALSE;
extern bool MACDalerts = FALSE;
bool Gi_192 = FALSE;
extern bool alertsMessage = FALSE;
extern bool alertsSound = FALSE;
extern bool alertsEmail = FALSE;
extern string soundfile = "news.wav";
double G_ibuf_216[];
double G_ibuf_220[];
double G_ibuf_224[];
double Gda_228[];
double G_ibuf_232[];
double Gda_236[];
double G_ibuf_240[];
string Gs_244;
string Gs_nothing_252 = "nothing";
datetime G_time_260;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   string Ls_0;
   IndicatorBuffers(8);
   SetIndexBuffer(0, G_ibuf_216);
   SetIndexBuffer(1, G_ibuf_220);
   SetIndexBuffer(2, G_ibuf_232);
   SetIndexBuffer(4, G_ibuf_224);
   SetIndexBuffer(7, G_ibuf_240);
   IndicatorDigit(Digits+2);
   SetIndexStyle(2, DRAW_NONE);
   if (Gi_100) SetIndexStyle(6, DRAW_LINE);
   else SetIndexStyle(6, DRAW_NONE);
   if (Gi_108) {
      SetIndexStyle(4, DRAW_NONE);
      SetIndexStyle(5, DRAW_LINE);
   } else {
      SetIndexStyle(4, DRAW_NONE);
      SetIndexStyle(5, DRAW_NONE);
   }
   if (MACDType == 1) Ls_0 = "ZeroLag MACD (";
   else Ls_0 = "MACD (";
   Ls_0 = Ls_0 + FastEMA + "," + SlowEMA + "," + SignalEMA + ")";
   switch (MACDType) {
   case 2:
      Ls_0 = Ls_0 + " of RSI       (" + RSIPeriod + ")";
      break;
   case 3:
      Ls_0 = Ls_0 + " of Momentum  (" + MOMPeriod + ")";
      break;
   case 4:
      Ls_0 = Ls_0 + " of CCI       (" + CCIPeriod + ")";
      break;
   case 5:
      Ls_0 = Ls_0 + " of Stochastic(" + StoK_period + "," + StoD_period + "," + StoSl_period + ")";
   }
   IndicatorShortName(Ls_0);
   Gs_244 = WindowExpertName();
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double Ld_0 = 2.0 / (SignalEMA + 1.0);
   int Li_8 = IndicatorCounted();
   if (Li_8 < 0) return (-1);
   if (Li_8 > 0) Li_8--;
   int Li_16 = Bars - Li_8;
   if (_ == "DoingZeroLag") {
      f0_0(Li_16);
      return (0);
   }
   for (int Li_12 = Li_16; Li_12 >= 0; Li_12--) {
      switch (MACDType) {
      case 2:
         G_ibuf_240[Li_12] = iRSI(NULL, 0, RSIPeriod, PriceType, Li_12);
         break;
      case 3:
         G_ibuf_240[Li_12] = iMomentum(NULL, 0, MOMPeriod, PriceType, Li_12);
         break;
      case 4:
         G_ibuf_240[Li_12] = iCCI(NULL, 0, CCIPeriod, PriceType, Li_12);
         break;
      case 5:
         G_ibuf_240[Li_12] = iStochastic(NULL, 0, StoK_period, StoD_period, StoSl_period, StoMain_MaMode, StoPriceField, MODE_MAIN, Li_12);
         break;
      default:
         G_ibuf_240[Li_12] = iMA(NULL, 0, baseMaPeriod, 0, baseMaMode, PriceType, Li_12);
      }
   }
   for (Li_12 = Li_16; Li_12 >= 0; Li_12--) {
      if (MACDType == 1) {
         G_ibuf_224[Li_12] = iCustom(NULL, 0, Gs_244, "DoingZeroLag", FastEMA, SlowEMA, SignalEMA, PriceType, 0, Li_12);
         G_ibuf_232[Li_12] = iCustom(NULL, 0, Gs_244, "DoingZeroLag", FastEMA, SlowEMA, SignalEMA, PriceType, 1, Li_12);
      } else {
         G_ibuf_224[Li_12] = iMAOnArray(G_ibuf_240, 0, FastEMA, 0, MODE_EMA, Li_12) - iMAOnArray(G_ibuf_240, 0, SlowEMA, 0, MODE_EMA, Li_12);
         G_ibuf_232[Li_12] = G_ibuf_232[Li_12 + 1] + Ld_0 * (G_ibuf_224[Li_12] - (G_ibuf_232[Li_12 + 1]));
      }
      G_ibuf_216[Li_12] = EMPTY_VALUE;
      G_ibuf_220[Li_12] = EMPTY_VALUE;
      Gda_228[Li_12] = EMPTY_VALUE;
      if (G_ibuf_232[Li_12] > G_ibuf_232[Li_12 + 1]) {
         G_ibuf_216[Li_12] = G_ibuf_232[Li_12];
         G_ibuf_216[Li_12 + 1] = G_ibuf_232[Li_12 + 1];
      }
      if (G_ibuf_232[Li_12] < G_ibuf_232[Li_12 + 1]) {
         G_ibuf_220[Li_12] = G_ibuf_232[Li_12];
         G_ibuf_220[Li_12 + 1] = G_ibuf_232[Li_12 + 1];
      }
   }
   if (alertsOn) {
      if (MACDalerts) {
         if (G_ibuf_224[0] > 0.0 && G_ibuf_224[1] < 0.0) f0_1("macd line crossed 0 up ");
         if (G_ibuf_224[0] < 0.0 && G_ibuf_224[1] > 0.0) f0_1("macd line crossed 0 down ");
      }
      if (Gi_192 || MACDalerts) {
         if (G_ibuf_232[0] < G_ibuf_224[0] && G_ibuf_232[1] > G_ibuf_224[1]) f0_1("osma crossed 0 (macd crossed signal line) up ");
         if (G_ibuf_232[0] > G_ibuf_224[0] && G_ibuf_232[1] < G_ibuf_224[1]) f0_1("osma crossed 0 (macd crossed signal line) down ");
      }
      if (Gi_192) {
         if (Gda_236[0] > Gda_236[1] && Gda_236[2] > Gda_236[1]) f0_1("osma macd(histo)changed direction: up ");
         if (Gda_236[0] < Gda_236[1] && Gda_236[2] < Gda_236[1]) f0_1("osma macd(histo)changed direction: down ");
      }
   }
   return (0);
}

// 020DAB222A1307FCC1183C9B863705CD
void f0_0(int Ai_0) {
   double Ld_8;
   double Ld_16;
   for (int Li_4 = Ai_0; Li_4 >= 0; Li_4--) {
      G_ibuf_224[Li_4] = iMA(NULL, 0, FastEMA, 0, MODE_EMA, PriceType, Li_4);
      Gda_228[Li_4] = iMA(NULL, 0, SlowEMA, 0, MODE_EMA, PriceType, Li_4);
   }
   for (Li_4 = Ai_0; Li_4 >= 0; Li_4--) {
      Ld_8 = G_ibuf_224[Li_4] + G_ibuf_224[Li_4] - iMAOnArray(G_ibuf_224, 0, FastEMA, 0, MODE_EMA, Li_4);
      Ld_16 = Gda_228[Li_4] + Gda_228[Li_4] - iMAOnArray(Gda_228, 0, SlowEMA, 0, MODE_EMA, Li_4);
      G_ibuf_216[Li_4] = Ld_8 - Ld_16;
   }
   for (Li_4 = Ai_0; Li_4 >= 0; Li_4--) G_ibuf_224[Li_4] = iMAOnArray(G_ibuf_216, 0, SignalEMA, 0, MODE_EMA, Li_4);
   for (Li_4 = Ai_0; Li_4 >= 0; Li_4--) G_ibuf_220[Li_4] = G_ibuf_224[Li_4] + G_ibuf_224[Li_4] - iMAOnArray(G_ibuf_224, 0, SignalEMA, 0, MODE_EMA, Li_4);
}

// DA717D55A7C333716E8D000540764674
void f0_1(string As_0) {
   string str_concat_8;
   if (Gs_nothing_252 != As_0 || G_time_260 != Time[0]) {
      Gs_nothing_252 = As_0;
      G_time_260 = Time[0];
      str_concat_8 = StringConcatenate(Symbol(), " ", As_0, " at ", TimeToStr(TimeLocal(), TIME_SECONDS));
      if (alertsMessage) Alert(str_concat_8);
      if (alertsSound) PlaySound(soundfile);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), " MACD crossing"), str_concat_8);
   }
}
